package net.sys42.dakedres.grafting;

import eu.pb4.polymer.core.api.block.PolymerBlockUtils;
import eu.pb4.polymer.resourcepack.api.PolymerModelData;
import eu.pb4.polymer.resourcepack.api.PolymerResourcePackUtils;
import net.fabricmc.api.ModInitializer;

import net.fabricmc.fabric.api.object.builder.v1.block.entity.FabricBlockEntityTypeBuilder;
import net.minecraft.block.AbstractBlock;
import net.minecraft.block.Block;
import net.minecraft.block.entity.BlockEntityType;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.util.Identifier;
import net.sys42.dakedres.grafting.blocks.Workbench;
import net.sys42.dakedres.grafting.blocks.WorkbenchBlockEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Grafting implements ModInitializer {
	public static final String MOD_ID = "grafting";

	// This logger is used to write text to the console and the log file.
	// It is considered best practice to use your mod id as the logger's name.
	// That way, it's clear which mod wrote info, warnings, and errors.
	public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);

	public static final Identifier WORKBENCH_ID = Identifier.of(Grafting.MOD_ID, "workbench");
	public static final Block WORKBENCH = Registry.register(
			Registries.BLOCK, WORKBENCH_ID,
			new Workbench(AbstractBlock.Settings.create().sounds(BlockSoundGroup.WOOD))
	);
	public static final BlockEntityType<WorkbenchBlockEntity> WORKBENCH_BLOCK_ENTITY_TYPE = Registry.register(
			Registries.BLOCK_ENTITY_TYPE,
			WORKBENCH_ID,
			FabricBlockEntityTypeBuilder.create(WorkbenchBlockEntity::new, WORKBENCH).build()
	);
	public static final BlockItem WORKBENCH_ITEM = Registry.register(
			Registries.ITEM, WORKBENCH_ID,
			new Workbench.WorkbenchItem(WORKBENCH, new Item.Settings())
	);

	@Override
	public void onInitialize() {
		// This code runs as soon as Minecraft is in a mod-load-ready state.
		// However, some things (like resources) may still be uninitialized.
		// Proceed with mild caution.

		LOGGER.info("Hello Fabric world!");

		PolymerBlockUtils.registerBlockEntity(WORKBENCH_BLOCK_ENTITY_TYPE);

		if (PolymerResourcePackUtils.addModAssets(MOD_ID)) {
			LOGGER.info("Successfully added mod assets for " + MOD_ID);
		} else {
			LOGGER.error("Failed to add mod assets for " + MOD_ID);
		}
		PolymerResourcePackUtils.markAsRequired();
	}
}