package net.sys42.dakedres.grafting;

public class PlacementMatrixUtils {
	public static final int[][] ROTATION_MATRICES = {
			{ 0,1,2,3,4,5,6,7,8 },
			{ 1,2,5,0,4,8,3,6,7 },
			{ 2,5,8,1,4,7,0,3,6 },
			{ 5,8,7,2,4,6,1,0,3 },
			{ 8,7,6,5,4,3,2,1,0 },
			{ 7,6,3,8,4,0,5,2,1 },
			{ 6,3,0,7,4,1,8,5,2 },
			{ 3,0,1,6,4,2,7,8,5 }
	};


//	public static DefaultedList<ItemStack> rotate(DefaultedList<ItemStack> grid, int direction) {
//		DefaultedList<ItemStack> o = DefaultedList.ofSize(grid.size(), ItemStack.EMPTY);
//		int[] rotationMatrix = ROTATION_MATRICES[(direction < 0 ? 8 - direction : direction) % 8];
//
//		for(int i = 0; i < grid.size(); i++) {
//			o.set(rotationMatrix[i], grid.get(i));
//		}
//
//		return o;
//	}

	public static int clampRotation(int rotation) {
		return (rotation < 0 ? 8 + rotation : rotation) % 8;
	}

	public static int[] getRotationMatrix(int rotation) {
		return ROTATION_MATRICES[clampRotation(rotation)];
	}

	public static int[] rotate(int[] matrix, int rotation) {
		int[] o = new int[matrix.length];
		int[] rotationMatrix = ROTATION_MATRICES[rotation];

		for(int i = 0; i < matrix.length; i++) {
			o[rotationMatrix[i]] = matrix[i];
		}

		return o;
	}

	public static int[] getPlacements() {
		int[] placements = {
				2,0,8,
				1,3,4,
				7,6,5
		};
		int[] out = new int[9];

		for(int i = 0; i < 9; i++) {
			out[placements[i]] = i;
		}

		return out;
	}
}
