package net.sys42.dakedres.grafting.blocks;

import com.mojang.serialization.MapCodec;
import eu.pb4.polymer.core.api.block.PolymerBlock;
import eu.pb4.polymer.core.api.item.PolymerItem;
import net.minecraft.block.Block;
import net.minecraft.block.BlockState;
import net.minecraft.block.BlockWithEntity;
import net.minecraft.block.Blocks;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.util.ActionResult;
import net.minecraft.util.collection.DefaultedList;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.sys42.dakedres.grafting.Grafting;
import org.jetbrains.annotations.Nullable;

public class Workbench extends BlockWithEntity implements PolymerBlock {
	private final DefaultedList<ItemStack> stacks = DefaultedList.ofSize(9, ItemStack.EMPTY);

	public Workbench(Settings settings) {
		super(settings);
	}

	@Override
	protected MapCodec<? extends BlockWithEntity> getCodec() {
		return createCodec(Workbench::new);
	}

	@Override
	public @Nullable BlockEntity createBlockEntity(BlockPos pos, BlockState state) {
		return new WorkbenchBlockEntity(pos, state);
	}

	@Override
	public BlockState getPolymerBlockState(BlockState blockState) {
		return Blocks.CRAFTING_TABLE.getDefaultState();
	}

	@Override
	protected ActionResult onUse(BlockState state, World world, BlockPos pos, PlayerEntity player, BlockHitResult hit) {
		if(!player.isSneaking() && world.getBlockEntity(pos) instanceof WorkbenchBlockEntity blockEntity) {
			blockEntity.openMenu((ServerPlayerEntity) player);
			return ActionResult.SUCCESS;
		}

		return super.onUse(state, world, pos, player, hit);
	}

	public static final class WorkbenchItem extends BlockItem implements PolymerItem {
		public WorkbenchItem(Block block, Settings settings) {
			super(block, settings);
		}

		@Override
		public Item getPolymerItem(ItemStack itemStack, @Nullable ServerPlayerEntity serverPlayerEntity) {
			return Items.CRAFTING_TABLE;
		}
	}
}
